#include "GBase.h"
#include "GArgs.h"
#include "GStr.h"

#define USAGE "Usage:\n\
gtest [-g|--genomic-fasta <genomic_seqs_fasta>] [-c|COV=<cov%>] \n\
 [-s|--seq <seq_info.fsize>] [-o|--out <outfile.gff>] [--disable-flag] [-t|--test <string>]\n\
 [-p|PID=<pid%>] file1 [file2 file3 ..]\n\
 "
enum {
 OPT_HELP=1,
 OPT_GENOMIC,
 OPT_COV,
 OPT_SEQ,
 OPT_OUTFILE,
 OPT_DISABLE_FLAG,
 OPT_TEST,
 OPT_PID,
};

GArgsDef opts[] = {
{"help",          'h', 0, OPT_HELP},
{"genomic-fasta", 'g', 1, OPT_GENOMIC},
{"COV",           'c', 1, OPT_COV},
{"seq",           's', 1, OPT_SEQ},
{"out",           'o', 1, OPT_OUTFILE},
{"disable-flag",   0,  0, OPT_DISABLE_FLAG},
{"test",          't', 1, OPT_TEST},
{"PID",           'p', 1, OPT_PID},
{0,0,0,0}
};

int main(int argc, char * const argv[]) {
 //GArgs args(argc, argv, "hg:c:s:t:o:p:help;genomic-fasta=COV=PID=seq=out=disable-flag;test=");
 GArgs args(argc, argv, opts);
 fprintf(stderr, "Command line was:\n");
 args.printCmdLine(stderr);
 args.printError(USAGE, true);
 //if (args.getOpt('h') || args.getOpt("help"))
 if (args.getOpt(OPT_HELP))
     {
     GMessage("%s\n", USAGE);
     exit(1);
     }
 int numopts=args.startOpt();
 if (numopts)
   GMessage("#### Recognized %d option arguments:\n", numopts);
 int optcode=0;
 while ((optcode=args.nextCode())) {
   char* r=args.getOpt(optcode);
   GMessage("%14s\t= %s\n", args.getOptName(optcode), (r[0]==0)?"True":r);
   }
 int numargs=args.startNonOpt();
 if (numargs>0) {
   GMessage("\n#### Found %d non-option arguments given:\n", numargs);
   char* a=NULL;
   while ((a=args.nextNonOpt())) {
     GMessage("%s\n",a);
     }
   }
}
